<?

class chart3D extends chart {

 
 var $ticks = 10;
 
 var $max_y;
 
 var $min_y;
 
 var $tick_color = 'BBBBBB'; 
 
 var $grid_color = '000000';
 
 var $space = 0.25;
 
 var $get_next_10_base = true;
 
 var $get_next_round = true;
 
 var $graph_type = "bargrid";

 function chart3D($d) {
 parent::chart($d);
 }
 
 function init_3D() {
 if ($this->graph_type == "singlebars") {
 for ($i = 0; $i < $this->grid_x_size; $i++) {
 $s = 0;
 for ($j = 0; $j < $this->grid_z_size; $j++) {
 $s += $this->grid[$i][$j]["val"];
 }
 if ($s < 0) $this->min_y = min($this->min_y, $s);
 if ($s > 0) $this->max_y = max($this->max_y, $s);
 }
 }
 
 if (!$this->max_y && !$this->min_y) {
 $this->min_y = $this->grid_min_y;
 $this->max_y = $this->grid_max_y;
 }
 
 if ($this->get_next_10_base) {
 $this->min_x = -pow(10, floor(log10(abs($this->min_y)))+1);
 $this->max_x = pow(10, floor(log10($this->max_y))+1);
 } else if ($this->get_next_round) {
 $i = pow(10, floor(log10(abs($this->min_y))));
 $this->min_x = -(floor(abs($this->min_y)/$i)+1)*$i;
 $i = pow(10, floor(log10($this->max_y)));
 $this->max_x = (floor($this->max_y/$i)+1)*$i;
 }
 
 $this->graph_min_x = 0;
 $this->graph_max_x = $this->grid_x_size;
 $this->graph_min_y = $this->min_y;
 $this->graph_max_y = $this->max_y;
 $this->graph_min_z = 0;
 $this->graph_max_z = ($this->graph_type == "singlebars")?1:$this->grid_z_size;
 
 parent::init_3D();
 }

 function render() {
 
 
 $z = ($this->graph_type == "singlebars")?1:$this->grid_z_size;
 for ($i = 0; $i < $this->ticks; $i++) {
 $y = $this->min_y + ($this->max_y - $this->min_y)*$i/$this->ticks;
 parent::draw_line(0,$y,0,0,$y,$z,$this->tick_color);
 parent::draw_line(0,$y,$z,$this->grid_x_size,$y,$z,$this->tick_color);
 }
 parent::draw_line(0,0,0,0,0,$z,$this->grid_color);
 parent::draw_line(0,0,$z,$this->grid_x_size,0,$z,$this->grid_color);
 parent::draw_line(0,$this->min_y,0,0,$this->min_y,$z,$this->grid_color);
 parent::draw_line(0,$this->min_y,$z,$this->grid_x_size,$this->min_y,$z,$this->grid_color);
 parent::draw_line(0,$this->max_y,0,0,$this->max_y,$z,$this->grid_color);
 parent::draw_line(0,$this->max_y,$z,$this->grid_x_size,$this->max_y,$z,$this->grid_color);
 parent::draw_line(0,$this->min_y,0,0,$this->max_y,0,$this->grid_color);
 parent::draw_line(0,$this->min_y,$z,0,$this->max_y,$z,$this->grid_color);
 parent::draw_line($this->grid_x_size,$this->min_y,$z,$this->grid_x_size,$this->max_y,$z,$this->grid_color);
 
 parent::draw_text("0",-0.1,0,0,0,"middleright");
 if ($this->min_y < 0) parent::draw_text($this->min_y,-0.1,$this->min_y,0,0,"middleright");
 if ($this->max_y > 0) parent::draw_text($this->max_y,-0.1,$this->max_y,0,0,"middleright");


 
 if ($this->graph_type == "bargrid") {
 for ($i = $this->grid_z_size - 1; $i >= 0; $i--) {
 for ($j = 0; $j < $this->grid_x_size; $j++) {
 parent::draw_cube($j + $this->space / 2, 0, $i + $this->space / 2, $this->grid[$j][$i]["val"], 1- $this->space, 1 - $this->space, $this->grid[$j][$i]["color"]);
 parent::draw_line($j,0,$i,$j + 1,0,$i, $this->grid_color);
 parent::draw_line($j+1,0,$i,$j+1,0,$i+1, $this->grid_color);
 }
 }
 } else if ($this->graph_type == "singlebars") {
 for ($i = 0; $i < $this->grid_x_size; $i++) {
 $s = 0;
 for ($j = 0; $j < $this->grid_z_size; $j++) {
 parent::draw_cube($i + $this->space / 2, $s, $this->space / 2, $this->grid[$i][$j]["val"], 1- $this->space, 1 - $this->space, $this->grid[$i][$j]["color"]);
 $s += $this->grid[$i][$j]["val"];
 }
 parent::draw_line($i,0,0,$i+1,0,0, $this->grid_color);
 parent::draw_line($i+1,0,0,$i+1,0,1, $this->grid_color);
 }
 }

 }

 function set($name, $value) {

 parent::set($name,$value);
 }

 function error_check() {

 parent::error_check();
 }

}

srand(time());
$d = array(
 array(rand(0,6),rand(0,6),rand(0,6)),
 array(rand(0,6),rand(0,6),rand(0,6)),
 array(rand(0,6),rand(0,6),rand(0,6)),
 array(rand(0,6),rand(0,6),rand(0,6))
 );

$f = array('ff0000','0000ff','00ff00');

$c = new chart3D($d);
$c->set('color',$f);
$c->set('first_islabel',false);
$c->set('draw_type','shadow');
$c->set('x_rotate',0.5);
$c->set('y_rotate',0.5);
$c->set('render_type','perspective');
$c->set('render_type','ISO');
$c->set('graph_type','singlebars');
$c->set('max_y',18);
$c->display();

?>
