<?

define( "GUI_MESSAGE_ERROR", 1 );
define( "GUI_MESSAGE_WARNING", 2 );
define( "GUI_MESSAGE_INFO", 3 );
define( "GUI_MESSAGE_DEBUG", 4 );

class GUIObject extends BaseObject {

 var $mainGUI;
 var $guiName;
 var $m_includeJS = array();
 var $m_includeBodyJS = array();
 var $m_includeCSS = array();
 var $m_CSSEnabled = TRUE;
 var $m_plain = FALSE;
 var $m_minimalJS = FALSE;
 var $m_noJS = FALSE;
 var $m_isBodyEnabled = TRUE;
 var $m_isBodyTagEnabled = TRUE;
 var $m_messages = array();
 var $d_dynamicTags = array();

 function GUIObject($name) {
 parent::BaseObject();
 $this->mainGUI = NULL;
 $this->guiName = $name;
 }
 
 function setMainGUI(&$parent) {
 $this->mainGUI =& $parent;
 }

 function isMainGUI() {
 return (!is_object($this->mainGUI) || $this->mainGUI == NULL);
 }
 
 function getFramePrefix() {
 }
 
 function getGUIName() {
 return $this->guiName;
 }
 
 function includeJS($name) {
 
 
 $excludearr = array("tools","layer");
 if ( in_array($name,$excludearr) ) return;

 
 
 if ($this->m_includeJS[$name] === FALSE) {
 return;
 }
 $this->m_includeJS[$name] = TRUE;
 }
 
 



 function excludeJS($name) {
 $this->m_includeJS[$name] = FALSE;
 }

 function includeCSS($include) {
 if ( ! in_array($include, $this->m_includeCSS) ) {
 $this->m_includeCSS[] = $include;
 }
 }

 function includeBodyJS( $name )
 {
 
 $excludearr = array("tools","layer");
 if ( in_array($name,$excludearr) ) return;
 
 $this->m_includeBodyJS[$name] = TRUE;
 }
 
 function setNoJSEnabled( $enabled )
 {
 $this->m_noJS = $enabled;
 }
 
 function isNoJSEnabled()
 {
 return $this->m_noJS;
 }
 
 function setMinimalJSEnabled( $enabled )
 {
 $this->m_minimalJS = $enabled;
 }
 
 function isMinimalJSEnabled()
 {
 return $this->m_minimalJS || $this->m_noJS;
 }
 
 function setCSSEnabled( $enabled )
 {
 $this->m_CSSEnabled = $enabled;
 }
 
 function isCSSEnabled()
 {
 return $this->m_CSSEnabled;
 }

 function setPlain( $enabled ) {
 $this->m_plain = $enabled;
 }

 function isPlain() {
 return $this->m_plain;
 }
 
 function setBodyEnabled( $enabled )
 {
 $this->m_isBodyEnabled = $enabled;
 }
 
 function isBodyEnabled()
 {
 return $this->m_isBodyEnabled;
 }
 
 function setBodyTagEnabled( $enabled )
 {
 $this->m_isBodyTagEnabled = $enabled;
 }
 
 function isBodyTagEnabled()
 {
 return $this->m_isBodyTagEnabled && $this->m_isBodyEnabled;
 }
 
 function _getJSIncludes()
 {
 if ( $this->isPlain() ) return;
 global $SID, $DEBUG, $STAG_PREFIX;
 $ret = "\n";
 $time = ($DEBUG["force_reloadjs"])?"&time=".time():"";
 foreach ( $this->m_includeJS as $key=>$value )
 {
 if ($value === TRUE) {
 $ret .= '<script type="text/javascript" language="javascript" src="'.$STAG_PREFIX.'?sid='.$SID.$time.'&do=20&url=lib/js/'.$key.'.js"></script>' . "\n";
 }
 }
 return $ret;
 }

 function _getCSSIncludes() {
 global $STAG_PREFIX, $SID;
 $html = "";
 foreach ($this->m_includeCSS as $include) {
 $html .= '<link rel="stylesheet" type="text/css"'
 . ' href="'.$STAG_PREFIX.'?sid='.$SID.'&do=20&url=lib/css/'.$include.'.css"/>'."\n";
 }
 return $html;
 }

 function _getJSBodyIncludes()
 {
 if ( $this->isPlain() ) return;
 global $SID, $DEBUG, $STAG_PREFIX;
 $ret = "\n";
 $time = ($DEBUG["force_reloadjs"])?"&time=".time():"";
 foreach ( $this->m_includeBodyJS as $key=>$value )
 {
 $ret .= '<script type="text/javascript" language="javascript" src="'.$STAG_PREFIX.'?sid='.$SID.$time.'&do=20&url=lib/js/'.$key.'.js"></script>' . "\n";
 }
 return $ret;
 }

 
 function _getNudity()
 {
 $nude = array();
 if ( !$this->isCSSEnabled() )
 $nude[] = "nocss";
 if ( $this->isMinimalJSEnabled() )
 $nude[] = "minjs";
 if ( $this->isNoJSEnabled() )
 $nude[] = "nojs";
 if ( !$this->isBodyEnabled() )
 $nude[] = "nobody";
 if ( !$this->isBodyTagEnabled() )
 $nude[] = "nobodytag";
 return $nude;
 }
 
 function _getParentHeader() {
 if ( $this->isPlain() ) return;
 if (!$this->isMainGUI()) return "";
 
 $header = ""; 
 $keys = GUIFactory::getGUIList();
 foreach ($keys as $key) {
 if ($key == $this->guiName) continue;
 $gui =& GUIFactory::getGUI($key);
 if ($gui->isMainGUI()) continue;
 $header .= $gui->getPassiveHeader($this);
 }
 global $HTML_HEAD, $JS_HEAD;
 $JS_HEAD .= $this->_getJSIncludes();
 $HTML_HEAD .= $header;
 $HTML_HEAD .= $this->_getCSSIncludes();
 
 return html_header($this->_getNudity());
 }

 function _getParentHTML() {
 if ( $this->isPlain() ) return;
 if (!$this->isMainGUI()) return "";
 
 $keys = GUIFactory::getGUIList();
 $html = "";
 $html .= $this->_getJSBodyIncludes();
 foreach ($keys as $key) {
 if ($key == $this->guiName) continue;
 unset($gui);
 $gui =& GUIFactory::getGUI($key);
 if ($gui->isMainGUI()) continue;
 $html .= $gui->getPassiveHTML($this);
 }
 
 global $HTML_NODE_BODY;
 $HTML_NODE_BODY .= $html;
 return html_body($this->_getNudity());
 }

 function _getParentFooter() {
 if ( $this->isPlain() ) return;
 if (!$this->isMainGUI()) return "";
 
 $keys = GUIFactory::getGUIList();
 $html = "";
 foreach ($keys as $key) {
 if ($key == $this->guiName) continue;
 $gui =& GUIFactory::getGUI($key);
 if ($gui->isMainGUI()) continue;
 $html .= $gui->getPassiveFooter($this);
 }
 return $html . html_footer($this->_getNudity());
 }

 function addMessage( $type, $txt, $description="" )
 {
 global $JS;
 switch ( $type )
 {
 case GUI_MESSAGE_ERROR:
 if ( count( $this->m_messages[$type] ) == 0 )
 $JS .= "\nalert('".str_replace("\n", "\\n", addslashes($txt) ). "');";
 node_class( "alertstreaminfo" );
 $obj =& new AlertStreamInfo();
 break;
 case GUI_MESSAGE_WARNING:
 case GUI_MESSAGE_INFO:
 node_class( "infostreaminfo" );
 $obj =& new InfoStreamInfo();
 break;
 case GUI_MESSAGE_DEBUG:
 node_class( "debugstreaminfo" );
 $obj =& new DebugStreamInfo();
 break;
 }
 
 $obj->addMessage("", $icon, $txt, $description);
 $this->m_messages[$type][] = array("txt"=>$txt, "desc"=>$description);
 }
 
 function explodeInfoObject( &$obj )
 {
 $info = array();
 if (is_array($obj)) {
 $info = $obj;
 } else if (is_a($obj,"streaminfo")) {
 $info = $obj->getInfo();
 } else if (is_a($obj,"baseobject")) {
 $info["text"] = $obj->toString();
 } else {
 $info["text"] = $obj;
 }
 return $info;
 }
 
 function &getDynamicInfos() {
 $tags = array();
 ksort($this->d_dynamicTags);
 foreach ($this->d_dynamicTags as $key=>$val) {
 if (!is_array($val)) continue;
 foreach ($this->d_dynamicTags[$key] as $k=>$v) {
 $tags[] =& $this->d_dynamicTags[$key][$k];
 }
 }
 return $tags;
 }

 





 function addInfoObject( &$sInfo, $itemOrder = 0 ) {
 $this->d_dynamicTags[$itemOrder][] =& $sInfo;
 }

 
 function printHaltPage($halt_id, $detail) {
 global $HTMl_NODE_BODY, $NODEPATH, $TPL;
 echo $this->getHeader();
 $main =& GUIFactory::getMainGUI();
 $header = $main->getHeader();
 $body = $main->getHTML();
 echo $header.$body;
 include("$NODEPATH/modules/system/template/$TPL/halt.php");
 $footer = $main->getFooter();
 echo $footer;


 }
 
 






 function getPassiveHeader(&$main) {
 }
 
 






 function getPassiveHTML(&$main)
 {
 }

 function getPassiveFooter(&$main)
 {
 }
 
 
 




 function prepareOutput( $buffer ) {
 return $buffer;
 } 
 
 function sendHttpHeaders() {
 }
 
 function getHeader() {
 return $this->_getParentHeader();
 }

 function getHTML() {
 return $this->_getParentHTML();
 }
 
 function getFooter() {
 return $this->_getParentFooter();
 }
 
}

?>
