<?













function xnl_is_function( $str, &$pos )
{
 global $xnl_known_functions;
 
 foreach ( $xnl_known_functions as $func )
 {
 $fStrs = $func->getFunctionStrings();
 foreach ( $fStrs as $fStr )
 {
 $len = strlen($fStr);
 if ( substr($str, $pos, $len) == $fStr )
 {
 $nextCh = substr( $str, $pos+$len, 1 );
 if ( $nextCh == "(" || $nextCh == " " )
 {
 $pos += $len;
 return $func;
 }
 }
 }
 }
 return false;
}

global $xnl_known_functions;
$xnl_known_functions = array( 
 new XNL_Function_strToLower(),
 new XNL_Function_trim(),
 new XNL_Function_contains(),
 new XNL_Function_substr(),
 new XNL_Function_div(),
 new XNL_Function_isPublishing(),
 new XNL_Function_isPublishMode(),
 new XNL_Function_isEditMode(),
 new XNL_Function_isPreviewMode(),
 new XNL_Function_isLiveMode(),
 new XNL_Function_isRealMode()
 );

class XNL_Function
{
 




 function getFunctionStrings() {} 
 
 




 function getMinParamCount() {}
 
 
 







 function getMaxParamCount() { return $this->getMinParamCount(); }
 
 












 function execute( $params ) {}
 
 








 function raiseFunctionError( $description )
 {
 
 }
};


class XNL_Function_strToLower extends XNL_Function
{
 function getFunctionStrings()
 {
 return array( "strToLower" );
 }
 
 function getMinParamCount() 
 {
 return 1;
 }
 
 function execute( $params )
 {
 return strtolower( $params[0] );
 }
}

class XNL_Function_contains extends XNL_Function
{
 function getFunctionStrings()
 {
 return array( "contains" );
 }
 
 function getMinParamCount() 
 {
 return 2;
 }
 
 function execute( $params )
 {
 return (strpos( strtolower($params[0]), strtolower($params[1]) ) !== false)?1:0;
 }
}

class XNL_Function_substr extends XNL_Function
{
 function getFunctionStrings()
 {
 return array( "substr" );
 }
 
 function getMinParamCount() 
 {
 return 2;
 }
 
 function getMaxParamCount() 
 {
 return 3;
 }

 function execute( $params )
 {
 if ( is_numeric( $params[2] ) )
 $ret = substr( $params[0], $params[1], $params[2] );
 else
 $ret = substr( $params[0], $params[1] );
 return $ret;
 }
}



class XNL_Function_trim extends XNL_Function
{
 function getFunctionStrings()
 {
 return array( "trim" );
 }
 
 function getMinParamCount()
 {
 return 1;
 }
 
 function execute( $params )
 {
 return trim( $params[0] );
 }
}

class XNL_Function_div extends XNL_Function
{
 function getFunctionStrings()
 {
 return array( "div" );
 }
 
 function getMinParamCount()
 {
 return 2;
 }

 function getMaxParamCount()
 {
 return 3;
 }
 
 function execute( $params )
 {
 if (!$params[1]) return 0;
 $i = $params[0]/$params[1];
 switch ($params[2]) {
 case "ceil":
 return ceil($i);
 case "floor":
 return floor($i);
 case "float":
 return $i;
 case "round":
 default:
 return round($i);
 }
 
 }
}

class XNL_Function_isPublishing extends XNL_Function {
 function getFunctionStrings()
 {
 return array( "isPublishing" );
 }
 
 function getMinParamCount()
 {
 return 0;
 }
 
 function execute( $params )
 {
 global $IS_PUBLISHING;
 if ($IS_PUBLISHING) {
 return 1;
 } else {
 return 0;
 }
 }
}

class XNL_Function_isPublishMode extends XNL_Function {
 function getFunctionStrings() {
 return array( "isPublishMode" );
 }

 function getMinParamCount() {
 return 0;
 }

 function execute( $params ) {
 global $IS_PUBLISHING;
 if ($IS_PUBLISHING) {
 return 1;
 } else {
 return 0;
 }
 }
}

class XNL_Function_isPreviewMode extends XNL_Function {
 function getFunctionStrings() {
 return array( "isPreviewMode" );
 }

 function getMinParamCount() {
 return 0;
 }

 function execute( $params ) {
 global $IS_PREVIEWING;
 if ($IS_PREVIEWING) {
 return 1;
 } else {
 return 0;
 }
 }
}

class XNL_Function_isLiveMode extends XNL_Function {
 function getFunctionStrings() {
 return array( "isLiveMode" );
 }

 function getMinParamCount() {
 return 0;
 }

 function execute( $params ) {
 global $IS_LIVEVIEWING;
 if ($IS_LIVEVIEWING) {
 return 1;
 } else {
 return 0;
 }
 }
}

class XNL_Function_isEditMode extends XNL_Function {
 function getFunctionStrings() {
 return array( "isEditMode" );
 }

 function getMinParamCount() {
 return 0;
 }

 function execute( $params ) {
 global $IS_EDITING;
 if ($IS_EDITING) {
 return 1;
 } else {
 return 0;
 }
 }
}

class XNL_Function_isRealMode extends XNL_Function {
 function getFunctionStrings() {
 return array( "isRealMode" );
 }

 function getMinParamCount() {
 return 0;
 }

 function execute( $params ) {
 global $IS_REALEDITING;
 if ($IS_REALEDITING) {
 return 1;
 } else {
 return 0;
 }
 }
}

?>
